<?php
/*
Plugin Name: PHPBB Single Sign On
Version: 0.8.2
Plugin URI: http://www.onigoetz.ch/plugins/wordpress-phpbb-plugin/
Description: Connecte un site wordpress à PHPBB
Author: Stéphane Goetz
Author URI: http://www.onigoetz.ch
*/


//Installation
register_activation_hook( __FILE__, 'connect_phpbb_install');
function connect_phpbb_install(){
    $default_options = array(
        'path' => 'forum/'
    );
    add_option('connect_phpbb_options', $default_options);
}

//Options page
add_action('admin_menu', 'connect_phpbb_options_page');
function connect_phpbb_options_page() {
	add_options_page('PHP BB', 'PHP BB Options', 10, 'phpbb-single-sign-on/options.php');
}

include (dirname(__FILE__).'/common-functions.php');
include (dirname(__FILE__).'/module.phpbb.php');
include (dirname(__FILE__).'/module.wp.php');


// AUTHENTICATE
add_action('wp_authenticate_user','wpbb_login',10,2);
function wpbb_login($userdata,$password)
{
  // check to see if phpBB exists
  if(! file_exists(ABSPATH.'/'.PHPBBPATH.'config.php') )
     return $userdata;

  define('FROM_WP',TRUE);
  wpbb_phpBB3::getIdentity(); // Set up phpBB environment
  return wpbb_phpBB3::login($userdata->user_login,$password);
}

// LOGOUT
add_action('wp_logout','wpbb_logout');
function wpbb_logout(){
    if(!defined('FROM_WP')) define('FROM_WP',TRUE);

    if(file_exists(ABSPATH.'/'.PHPBBPATH.'config.php')){ // check to see if phpBB exists
        wpbb_phpBB3::getIdentity();
        wpbb_phpBB3::logout();
    }

    return false;
}

// PASSWORD CHANGES, when a user changes his password in wordpress, it applies to phpbb
add_filter('check_passwords', 'wpbb_change_password', 10, 3);
function wpbb_change_password($username, $pass1, $pass2){
    if(!empty($pass1) && !empty($pass2) && $pass1 == $pass2){
        wpbb_phpBB3::getIdentity();
        if(wpbb_phpBB3::getUserByName($username)){
            wpbb_phpBB3::changePassword($username,$pass1);
        }
    }
    return true;
}

// TEST , Runs tests in admin to show if the user has some configs to do.
add_action('init', 'wpbb_admin_warnings');
function wpbb_admin_warnings() {
    if ( wpbb_run_test(false) ) {
        function wpbb_warning() {
            echo "
            <div id='phpbb-warning' class='updated fade'>
            <p><strong>".__('PHP Single Sign On is almost ready.')."</strong>
                ".sprintf(__('You have to <a href="%s">Follow the instructions</a> for it to work.'),
                 get_option('siteurl') . '/wp-admin/admin.php?page=phpbb-single-sign-on/options.php')."</p></div>
            ";
        }
        add_action('admin_notices', 'wpbb_warning');
        return;
    }
}

////////////////////////////////////////////////////////////

add_action( 'register_post', 'wpbb_register_post', 10, 3 );
function wpbb_register_post($login,$email,$errors)
{
  if( $errors->get_error_code() ) return; // No need to add to the dispair

  if( wpbb_phpBB3::get_wp_user_by_email($email) )
    {
      $errors->add( 'email_exists', __( '<strong>ERROR</strong>: This email is already registered, please choose another one.' ) );
    }
}

////////////////////////////////////////////////////////////

add_action( 'register_post', 'wpbb_register_hint', 11, 3 );
function wpbb_register_hint($login,$email,$errors)
{
  error_log( $errors->get_error_code() );


  if( $errors->get_error_code() != 'email_exists' and
      $errors->get_error_code() != 'username_exists'
      ) return;

  $errors->add('email_exists', sprintf("<a href=\"%s\">%s</a>",
				       site_url('wp-login.php', 'login'),
				       __('Log In')));

  $errors->add('email_exists', sprintf("<a href=\"%s\" title=\"%s\">%s</a>",
				       site_url('wp-login.php?action=lostpassword',
						'recover password'),
				       __('Password Lost and Found'),
				       __('Lost your password?')));
}

////////////////////////////////////////////////////////////


if( !function_exists('get_user_by_email') ) :
  function get_user_by_email($email)
  {
    $user = get_user_by('email', $email);
    if(! $user )
      {
	$user = wpbb_phpBB3::get_wp_user_by_email( $email );
      }
    return $user;
  }
endif;

////////////////////////////////////////////////////////////

if ( !function_exists('get_userdatabylogin') ) :
  function get_userdatabylogin($user_login)
  {
    $user = get_user_by('login', $user_login);
    if(! $user )
      {
	$user = wpbb_phpBB3::get_wp_user_by_name( $user_login );
      }
    return $user;
  }
endif;

////////////////////////////////////////////////////////////
